<!DOCTYPE html>
<html
        lang="en"
        xmlns:th="http://www.thymeleaf.org"
        xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
        xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
        layout:decorate="~{layout3}"
>
<head>
  <meta charset="UTF-8" />
  <title>Fakultas</title>
</head>
<body>

<main
        layout:fragment="main"
        class="container-xxl bd-gutter mt-3 my-md-4 bd-layout"
>
  <div th:include="sidebar/sidebar_masterdata::sidebar_masterdata" th:remove="tag">
    sidebar
  </div>


  <main class="bd-main-xxl">
    <div class="row">
      <div class="col-md-12">
        <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
          <i class="fa fa-circle text-secondary" ></i> Fakultas
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-md-12">
        <div class="alert alert-success mb-3" role="alert" th:if="${berhasil != null}">
          <i class="fa fa-check"></i> <span th:text="${berhasil}"></span>
        </div>
        <div class="card shadow-sm border-0">
          <div class="card-header p-4">
            <div class="d-flex justify-content-between">
              <span class="fw-bold text-secondary">Daftar Fakultas</span>
              <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#fakultasModal">
                Tambah Fakultas
              </button>
            </div>
          </div>
          <div class="card-body pt-4 pb-0 border-0">
            <form method="get">
              <div class="row">

                <div class="col-md-9">
                  Show entries <span sd:page-size-selector="javascript"></span>
                </div>

                <div class="col-md-3" align="right">
                  <input
                          class="form-control me-2"
                          type="text"
                          placeholder="Search"
                          name="search"
                          th:value="${search}"
                          aria-label="Search"
                  />
                  <!--                <button class="btn btn-danger" type="submit" style="background-color: #15408d; border-color:#15408d">Log out</button>-->
                </div>

              </div>
              <br />
            </form>
          </div>

          <div class="card-body p-0 pb-0">
            <div class="table-responsive mb-0">
              <table class="table table-striped table-hover small mb-0">
                <thead>
                <tr>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0 text-end" scope="col" style="width: 10px">#</th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Kode</th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Nama Fakultas</th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Departemen</th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Prodi</th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                  <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                </tr>
                </thead>
                <tbody class="align-middle">
                <tr th:each="dataFakultas,row : ${listFakultas}">
                  <td class="border-start-0 border-end-0 text-end" th:text="${(row.index + 1) + (listFakultas.number * listFakultas.size)+'.'}">1.</td>
                  <td class="border-start-0 border-end-0" >
                    <span th:text="${dataFakultas.getKodeFakultas()}"></span>
                  </td>
                  <td class="border-start-0 border-end-0">
                    <span th:text="${dataFakultas.getNamaFakultas()}"></span>
                  </td>
                  <td class="border-start-0 border-end-0">
                    <span th:text="${dataFakultas.getDepartment().getDepartmentName()}"></span>
                  </td>
                  <td class="border-start-0 border-end-0">

                  </td>
                  <td class="border-start-0 border-end-0">
                    <!--                                    <a class="btn btn-primary btn-sm" th:href="@{/masterdata/department/edit(department = ${dataDepartment.id},search = ${search}, page = ${page.getPageNumber()}, size = ${page.getPageSize()})}" title="Edit">-->
                    <!--                                        <i class="fa fa-gear"></i>-->
                    <!--                                    </a>-->
                    <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal"
                            data-bs-target="#departmentModal" th:data-id="${dataFakultas.getId()}" onclick="loadFakultasData(this)">
                      <i class="fa fa-edit"></i>
                    </button>
                  </td>
                  <td class="border-start-0 border-end-0">
                    <form method="post" th:action="@{/masterdata/fakultas/delete(fakultas=${dataFakultas.id},search = ${search}, page = ${page.getPageNumber()}, size = ${size})}">
                      <button type="submit" class="btn btn-danger btn-sm"
                              onclick="return confirm('Are you sure want to delete this?')">
                        <i class="fa fa-trash"></i>
                      </button>
                    </form>
                  </td>
                </tr>
                </tbody>
              </table>
            </div>
          </div>

          <div class="card-footer text-end p-4 bg-body border-top-0">
            <nav aria-label="Page navigation example">
              <ul class="pagination" sd:pagination="full"></ul>
            </nav>
          </div>
        </div>
      </div>
    </div>

    <div class="modal fade" id="fakultasModal" tabindex="-1" aria-labelledby="fakultasModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg modal-dialog-centered">
        <div class="modal-content">
          <div class="modal-header bg-primary text-light">
            <h5 class="modal-title" id="fakultasModalLabel"><i class="fa fa-edit text-secondary"></i> Form fakultas</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <form class="form-horizontal" th:action="@{/masterdata/fakultas/save}" th:object="${fakultas}" method="post" enctype="multipart/form-data">
            <div class="modal-body">
              <div class="row">
                <div class="col-md-6">
                  <div class="mb-3">
                    <label for="kodeFakultas" class="form-label text-secondary">Kode</label>
                    <input type="text" class="form-control" id="kodeFakultas" th:field="*{kodeFakultas}">
                    <div th:if="${#fields.hasErrors('kodeFakultas')}" class="error-message" th:errors="*{kodeFakultas}" style="color: red;"></div>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="mb-3">
                    <label for="namaFakultas" class="form-label text-secondary">Nama</label>
                    <input type="text" class="form-control" id="namaFakultas" th:field="*{namaFakultas}">
                    <div th:if="${#fields.hasErrors('namaFakultas')}" class="error-message" th:errors="*{namaFakultas}" style="color: red;"></div>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="mb-3">
                    <label for="namaFakultasEnglish" class="form-label text-secondary">Nama (English)</label>
                    <input type="text" class="form-control" id="namaFakultasEnglish" th:field="*{namaFakultasEnglish}">
                    <div th:if="${#fields.hasErrors('namaFakultasEnglish')}" class="error-message" th:errors="*{namaFakultasEnglish}" style="color: red;"></div>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="mb-3">
                    <label for="department" class="form-label text-secondary">Departemen Terkait</label>
                    <select class="form-select" id="department" aria-label="Default select example" th:field="*{department}">
                      <option th:each="data : ${listDepartment}"
                              th:text="${data.getDepartmentName()}"
                              th:value="${data.getId()}">sdasd</option>
                    </select>
                    <div th:if="${#fields.hasErrors('department')}" class="error-message" th:errors="*{department}" style="color: red;"></div>
                  </div>
                  <input type="hidden" name="companies" id="companies" th:field="*{companies}">
                  <input type="hidden" name="search" th:value="${search}">
                  <input class="form-control" type="hidden" name="id" id="idFakultas" th:field="*{id}">
                  <input type="hidden" name="page" th:value="${page}">
                  <input type="hidden" name="size" th:value="${page.getPageSize()}">
                </div>
              </div>
            </div>
            <div class="modal-footer p-3">
              <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
              <button type="submit" class="btn btn-primary">Save</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </main>
</main>
</body>
</html>

<script>
  $('#fakultasModal').on('shown.bs.modal', function () {
    // Inisialisasi Select2 untuk 'fakultas' setelah modal ditampilkan

    // Inisialisasi Select2 untuk 'department' setelah modal ditampilkan
    $('#department').select2({
      theme: "bootstrap-5",
      width: '100%',  // Set width to 100% explicitly
      placeholder: 'Pilih Department',  // Tambahkan placeholder
      dropdownParent: $('#fakultasModal')  // Pastikan dropdown berada di dalam modal
    });
  });
</script>

<script>
  $(document).ready(function() {
    var hasErrors = $('.error-message').length > 0; // Memeriksa jika ada elemen dengan kelas error-message
    console.log("Has Errors:", hasErrors); // Menampilkan apakah ada error
    if (hasErrors) {
      console.log("Showing modal"); // Menampilkan pesan di console
      $('#fakultasModal').modal('show');
    }
  });
</script>
<script>

  // Load KPI data ke modal saat ingin mengedit
  function loadFakultasData(button) {
    const id = $(button).data('id');
    const modal = $('#fakultasModal');
    $.ajax({
      url: '/masterdata/fakultas/data/' + id,
      method: 'GET',
      success: function(response) {
        // Mengisi data ke dalam textarea dan input yang sesuai
        $('#fakultasModal #kodeFakultas').val(response.kodeFakultas);
        $('#fakultasModal #namaFakultas').val(response.namaFakultas);
        $('#fakultasModal #namaFakultasEnglish').val(response.namaFakultasEnglish);
        $('#fakultasModal #department').val(response.department.id);
        $('#fakultasModal #companies').val(response.companies.id);
        $('#fakultasModal #idFakultas').val(response.id);
        $('#fakultasModal').modal('show');  // Menampilkan modal setelah data diambil
        modal.find('#department').select2({
          theme: "bootstrap-5",
          width: '100%',
          dropdownParent: modal,  // Proper dropdownParent set to the modal
          //allowClear: true,       // Allows clearing the selection
          placeholder: "Pilih Department",  // Placeholder untuk select
          minimumResultsForSearch: 1  // Enables search when there is at least 1 option
        });
      },
      error: function(error) {
        console.error("Error fetching Department data:", error);
      }
    });
  }

  $('#fakultasModal').on('hidden.bs.modal', function() {
    // $(this).find('textarea, input, select').val(''); // Clear all textareas, inputs, and selects
    $(this).find('.form-control').val('');
    $(this).find('.form-select').val('');
    $('.error-message').empty();
  });


</script>





